An OpenGL 4.4+ text editor.

izzy f5cc681297 buffer annotations 4 days ago
config a5382ca7a2 cleaner grep arguments 4 months ago
images cf33287f08 file browser icons and sorting 4 years ago
src f5cc681297 buffer annotations 4 days ago
.gitignore af799fea30 session saving 1 year ago
DEVELOPMENT.md 1e12743664 log cleanup, valgrind bugfixes 9 months ago
LICENSE fe75e9b2b0 Initial commit 5 years ago
README.md c9493541d7 it's clever, but not clever enough 1 year ago
_build.c 616dfe170f quick and dirty filesystem monitoring 1 month ago
_build.inc.c cf04d0e0db build modes and new convenience scripts 1 year ago
build.sh cf04d0e0db build modes and new convenience scripts 1 year ago
debug.sh 4ec7e852f7 properly usable autocomplete, with commands and config tuning 1 year ago
mkhighlight.sh 9b1e7d88ae mkrelease does an install to minimize required user steps 1 year ago
mkrelease.sh d95f4f8174 be more cautious 1 year ago
profiling.sh cf04d0e0db build modes and new convenience scripts 1 year ago
setup.sh 1b5485a7d0 long overdue but still insufficient readme update 1 year ago
valgrind 6d424ca707 valgrind options change 3 years ago
valgrind-gl-suppress.supp f9dd157bf5 wildcard valgrind suppression 3 years ago
valgrind.sh cf04d0e0db build modes and new convenience scripts 1 year ago

README.md

gpuedit

An OpenGL 4.4+ text editor. Not done yet.

Requirements

  • Linux 2.6+
  • A reasonably modern CPU.
  • OpenGL 4.4+ capable hardware and drivers.
    • Note that some integrated Intel devices are capable of running gpuedit despite claiming to only support OpenGL 3.0, but with sub-optimal performance.

Installing

Automatically

The automatic setup script is out of date and should not be used.

Manually

  1. https://github.com/yzziizzy/c3dlas symlinked as src/c3dlas
  2. https://github.com/yzziizzy/c_json symlinked as src/c_json
  3. https://github.com/yzziizzy/sti symlinked as src/sti

  4. sudo apt-get install libx11-dev libglew-dev libfreetype6-dev libfontconfig1-dev libpng-dev libpcre3-dev

    1. Optional Dependencies: sudo apt-get install libjpeg-turbo8-dev alsa-source
  5. Compile the parser generator:

    1. cd src/sti/parser/ && ./build.sh
  6. For each highlighter in src/highlighters/:

    1. ./build.sh
    2. Copy or symlink the .so to /usr/local/lib/gpuedit/highlighters/
  7. Build gpuedit

    1. ./debug.sh

If you get build errors related to AVX or SSE4.1, try removing the appropriate compile flags in _build.c and commenting out C3DLAS_USE_SIMD in src/c3dlas/c3dlas.h. I'll remove all that old garbage eventually.